scala.tools.nsc.ast

# DocComments

#### trait DocComments extends AnyRef

Self Type
  Global
Source
  DocComments.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Global, ReflectGlobal
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. DocComments
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### case class DocComment(raw: String, pos: Global.Position = NoPosition, codePos: Global.Position = NoPosition) extends Product with Serializable

2. #### class ExpansionLimitExceeded extends Exception

3. #### case class UseCase(comment: Global.DocComment, body: String, pos: Global.Position) extends Product with Serializable

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from DocComments to any2stringadd[DocComments] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (DocComments, B)

   Implicit information
     This member is added by an implicit conversion from DocComments to ArrowAssoc[DocComments] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def clearDocComments(): Unit

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### def cookedDocComment(sym: Global.Symbol, docStr: String = ""): String

   The raw doc comment of symbol `sym`, minus usecase and define sections, augmented by missing sections of an inherited doc comment.

   The raw doc comment of symbol `sym`, minus usecase and define sections, augmented by missing sections of an inherited doc comment. If a symbol does not have a doc comment but some overridden version of it does, the doc comment of the overridden version is copied instead.

10. #### val cookedDocComments: HashMap[Global.Symbol, String]

11. #### def docCommentPos(sym: Global.Symbol): Global.Position

    The position of the raw doc comment of symbol `sym`, or NoPosition if missing If a symbol does not have a doc comment but some overridden version of it does, the position of the doc comment of the overridden version is returned instead.

12. #### val docComments: WeakHashMap[Global.Symbol, Global.DocComment]

    The raw doc comment map

    The raw doc comment map

    In IDE, background compilation runs get interrupted by reloading new sourcefiles. This is weak to avoid memleaks due to the doc of their cached symbols (e.g. in baseTypeSeq) between periodic doc reloads.

13. #### def ensuring(cond: (DocComments) ⇒ Boolean, msg: ⇒ Any): DocComments

    Implicit information
      This member is added by an implicit conversion from DocComments to Ensuring[DocComments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: (DocComments) ⇒ Boolean): DocComments

    Implicit information
      This member is added by an implicit conversion from DocComments to Ensuring[DocComments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean, msg: ⇒ Any): DocComments

    Implicit information
      This member is added by an implicit conversion from DocComments to Ensuring[DocComments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean): DocComments

    Implicit information
      This member is added by an implicit conversion from DocComments to Ensuring[DocComments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

18. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

19. #### def expandInheritdoc(parent: String, child: String, sym: Global.Symbol): String

    Expand inheritdoc tags

    Expand inheritdoc tags

    - for the main comment we transform the inheritdoc into the super variable, and the variable expansion can expand it further
    - for the param, tparam and throws sections we must replace comments on the spot

    This is done separately, for two reasons: 1. It takes longer to run compared to merge 2. The inheritdoc annotation should not be used very often, as building the comment from pieces severely impacts performance

    parent

      The source (or parent) comment

    child

      The child (overriding member or usecase) comment

    sym

      The child symbol

    returns

      The child comment with the inheritdoc sections expanded

20. #### def expandVariables(initialStr: String, sym: Global.Symbol, site: Global.Symbol): String

    Expand variable occurrences in string `str`, until a fix point is reached or an expandLimit is exceeded.

    Expand variable occurrences in string `str`, until a fix point is reached or an expandLimit is exceeded.

    initialStr

      The string to be expanded

    sym

      The symbol for which doc comments are generated

    site

      The class for which doc comments are generated

    returns

      Expanded string

    Attributes
      protected

21. #### def expandWiki(str: String): String

    Returns just the wiki expansion (this would correspond to a comment in the input format of the JavaDoc tool, modulo differences in tags.)

22. #### def expandedDocComment(sym: Global.Symbol, site: Global.Symbol, docStr: String = ""): String

    The cooked doc comment of symbol `sym` after variable expansion, or "" if missing.

    The cooked doc comment of symbol `sym` after variable expansion, or "" if missing.

    sym

      The symbol for which doc comment is returned

    site

      The class for which doc comments are generated

    Exceptions thrown
      ExpansionLimitExceeded

      when more than 10 successive expansions of the same string are done, which is interpreted as a recursive variable definition.

23. #### def fillDocComment(sym: Global.Symbol, comment: Global.DocComment): Unit

24. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

25. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from DocComments to StringFormat[DocComments] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

26. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

27. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

28. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

29. #### def lookupVariable(vble: String, site: Global.Symbol): Option[String]

    Lookup definition of variable.

    Lookup definition of variable.

    vble

      The variable for which a definition is searched

    site

      The class for which doc comments are generated

30. #### def merge(src: String, dst: String, sym: Global.Symbol, copyFirstPara: Boolean = false): String

    Merge elements of doccomment `src` into doc comment `dst` for symbol `sym`.

    Merge elements of doccomment `src` into doc comment `dst` for symbol `sym`. In detail:

    1. If `copyFirstPara` is true, copy first paragraph 2. For all parameters of `sym` if there is no @param section in `dst` for that parameter name, but there is one on `src`, copy that section. 3. If there is no @return section in `dst` but there is one in `src`, copy it.

31. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

32. #### final def notify(): Unit

    Definition Classes
      AnyRef

33. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

34. #### def rawDocComment(sym: Global.Symbol): String

    The raw doc comment of symbol `sym`, as it appears in the source text, "" if missing.

35. #### def replaceInheritDocToInheritdoc(docStr: String): String

36. #### def superComment(sym: Global.Symbol): Option[String]

    The cooked doc comment of an overridden symbol

    The cooked doc comment of an overridden symbol

    Attributes
      protected

37. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

38. #### def toString(): String

    Definition Classes
      AnyRef → Any

39. #### def useCases(sym: Global.Symbol, site: Global.Symbol): List[(Global.Symbol, String, Global.Position)]

    The list of use cases of doc comment of symbol `sym` seen as a member of class `site`.

    The list of use cases of doc comment of symbol `sym` seen as a member of class `site`. Each use case consists of a synthetic symbol (which is entered nowhere else), of an expanded doc comment string, and of its position.

    sym

      The symbol for which use cases are returned

    site

      The class for which doc comments are generated

    Exceptions thrown
      ExpansionLimitExceeded

      when more than 10 successive expansions of the same string are done, which is interpreted as a recursive variable definition.

40. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

42. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### def →[B](y: B): (DocComments, B)

    Implicit information
      This member is added by an implicit conversion from DocComments to ArrowAssoc[DocComments] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from DocComments to any2stringadd[DocComments]

### Inherited by implicit conversion StringFormat from DocComments to StringFormat[DocComments]

### Inherited by implicit conversion Ensuring from DocComments to Ensuring[DocComments]

### Inherited by implicit conversion ArrowAssoc from DocComments to ArrowAssoc[DocComments]

### Ungrouped